Components.utils.import("resource://livemargins/manager2.js");
Components.utils.import("resource://livemargins/grabpic.js"); 

var dndHandler = {
	getPref : function(name,def_val){
		var prefs = Application.extensions.get("livemargins@mozillaonline.com").prefs;
		return prefs.getValue(name,def_val);
	},
	dndObserver : null,
	init : function(){
		this.dndObserver = new DragDropObserver();
		this.dndObserver.attachWindow(window);
		this.dndObserver.addDragGestureListener(this);
	},
	unload : function(){
		this.dndObserver.removeDragGestureListener(this);
		this.dndObserver.detachWindow(window);
		this.dndObserver = null;		

	},
	get mainWindow() {
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		                   .getService(Components.interfaces.nsIWindowMediator);
		var mainWindow = wm.getMostRecentWindow("navigator:browser");
		return (mainWindow);
	},

	doSearchEngine: function(text, loadInBackground) {
		var searchService = Components.classes["@mozilla.org/browser/search-service;1"].
								getService(Components.interfaces.nsIBrowserSearchService);
		var engine = searchService.currentEngine;
		if (engine === null)
			return;
		
		var link = engine.getSubmission(text, null).uri.spec;
		this.openLink(link, loadInBackground);
	},
	
	openLink: function(link, loadInBackground) {
		this.mainWindow.getBrowser().loadOneTab(link, null, null, null, loadInBackground, false, true);
	},
	
	onDragGesture: function(event) {
		var deltaX = event.endX - event.startX;
		var deltaY = event.endY - event.startY;
		
		if (deltaX * deltaX + deltaY * deltaY <= 25) {
			// not drag long enough I think
			return false;
		}
		
		if (event.type === 'text') {
/* 			if (deltaX > 0) {
				if (deltaY >= 0 && deltaX - deltaY >= 0) {
					favpart_manager.doSearch(event.data);
					return true;
				}
				if (deltaY < 0 && deltaX + deltaY >= 0) {
					favpart_manager.doSearch(event.data);
					return true;
				}
			}
 */
 /*
	<menuitem label="ʹLM2"  value="0"/>
	<menuitem label="õǰں̨"     value="1"/>
	<menuitem label="õǰǰ̨"    value="2"/>
*/
			var value = 0;
			if (deltaY >= 0){
				value = this.getPref("textdown",0);
			} else {
				value = this.getPref("textup",0);
			}
			if (value == 0){
				favpart_manager.doSearch(event.data);
			} else if (value == 1){
				this.doSearchEngine(event.data, true);
			} else if (value == 2){
				this.doSearchEngine(event.data, false);
			}
			return true;
		} else if (event.type === 'link') {
			var value = 0;
			if (deltaY >= 0){
				value = this.getPref("linkdown",0);
			} else {
				value = this.getPref("linkup",0);
			}
			if (value == 0){
				this.openLink(event.data,true);
			} else if (value == 1){
				this.openLink(event.data,false);
			}
			return true;

			this.openLink(event.data, deltaY > 0);
			return true;
		} else if (event.type === 'image'){
			var value = this.getPref("imagedrag",true);
			if (value){
				var uri = event.data;
				var webUri = GrabPicturesService.getCurrentTabLink();
				var picId = GrabPicturesService.addPicture(uri, webUri, GrabPicturesService.DEFAULT_GROUP_ID);
				favpart_manager.doGrabPic(picId);
			}
				
		}
		return false;
	},

}

window.addEventListener("load",function(){
			window.removeEventListener("load",arguments.callee,false);
			dndHandler.init();
		},false);
window.addEventListener("unload",function(){
			window.removeEventListener("unload",arguments.callee,false);
			dndHandler.unload();
		},false);