﻿Components.utils.import("resource://livemargins/manager2.js");
window.setTimeout(function (){favpart_manager.init();},2000);
const wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
var Ci = Components.interfaces;
var Cc = Components.classes;

var favpart_widgetManager = {
	showHideTimeout : 500,
	debug : false,
	LOG : function(msg) {
		if (this.debug){
			try{
				var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
				consoleService.logStringMessage("FavPart: widgetManager: " + msg);
			} catch(e){}
		}
	},
	reportError : function(error){
		try {
			if(this.debug){
				Components.utils.reportError(error);
			}
		} catch (e){
			Components.utils.reportError(e);
		}
	},
	windowCount : 0,
	container : null,
	_stack : null,
	outerBox : null,
	_boxLabelHeight : 13,
	_trayIconController : null,
	hideAll : false,
	openedPopup : null,
	hoverTime : 350,
	openTimer : null,
	closeTimer : null,
	lastNode : null,
	withAll : false,
	init : function(){
		favpart_manager.widgetManagerWin = window;
		window.resizeTo(0,0);
		var strbundle = document.getElementById("livemarginsStrings");
		var tooltips = strbundle.getString("trayicon.tooltips");
		if (navigator.appVersion.indexOf("Win")!= -1 || navigator.appVersion.indexOf("Linux")!= -1){
			this._trayIconController = Components.classes["@mozillaonline.com/windowtrayicon;1"].createInstance();
			this._trayIconController = this._trayIconController.QueryInterface(Components.interfaces.IWindowTrayIcon);
			this._trayIconController.addTrayIcon(windowTools.getBaseWindow(),tooltips,this.trayCallback);
			this._trayIconController.addHotKey(11,0x53,true,true,false);
			this._trayIconController.addHotKey(12,0x57,true,true,false);
		}
		this.container = document.getElementById("widgetManager-container");
		this._stack = document.getElementById("widgetManager-stack");
		this.outerBox = document.getElementById("widgetManager-box");
		this.controlButtons = document.getElementById("widgetManager-control-buttons");
		this.windowLayerButton = document.getElementById("windowLayerButton");
//		this.transButton = document.getElementById("transparentButton");
		this.hideWinButton = document.getElementById("hideWindowButton");
		this.closeWinButton = document.getElementById("closeWindowButton");
//		this.LOG(this.outerBox.boxObject.width);
		window.resizeTo(this.outerBox.boxObject.width,this.outerBox.boxObject.height);
		setTimeout(function(){
				windowTools.windowLayer = 2;
				windowTools.onTaskbar = false;
				window.moveTo(window.screen.width - window.outerWidth,window.screen.availHeight - window.outerHeight);
				//windowTools.setRoundRgn();
			},0);
				this.updatePreviews();
	},
	uninit : function(){
		if (this.trayIconController){
			this.trayIconController.removeTrayIcon();
		}
	},
	getTrayIconController : function(){
		if (this._trayIconController == null){
			try{
				this._trayIconController = Components.classes["@mozillaonline.com/windowtrayicon;1"].createInstance();
				this._trayIconController = this._trayIconController.QueryInterface(Components.interfaces.IWindowTrayIcon);
			} catch (e){
				this.reportError(e);
			}
		} else {
			return this._trayIconController;
		}
	},
	trayCallback : function ( aEvent, aParam, aKeyMask, aMouseX, aMouseY ) {
		// note that |this| is the function itself
		var iface = Components.interfaces.favpart_trayIWindowCallback;
		var rv = false;

		switch (aEvent) {        
			case iface.EVENT_MOUSEDBLCLK_LEFT:
				var enumerator = wm.getEnumerator("mozilla:favpart_widget");
				if(enumerator.hasMoreElements()) {
					favpart_widgetManager.showAndHideAllWidgets();
					rv = true;
				} else {
					var panel = document.getElementById("widgetManager-menu");
					panel.openPopupAtScreen(aMouseX,aMouseY,true);
					rv = true;
				}
				break;
			case iface.EVENT_MOUSEUP_LEFT:
				try {
				// if there are two clicks within 300ms, pass the event, it's a double click
					if (favpart_widgetManager.clickedOnce){
					//second one!
						favpart_widgetManager.clickedOnce = false;
					}else {
					//first one
						favpart_widgetManager.clickedOnce = true;
						window.setTimeout(function(){
								if (favpart_widgetManager.clickedOnce){
									favpart_widgetManager.clickedOnce = false;
									
									// execute
									var panel = document.getElementById("fastLaunch-popup");
									panel.openPopupAtScreen(aMouseX,aMouseY,true);
									favpart_widgetManager.fastLaunchOpenFrom = {x:aMouseX,y:aMouseY}

								}
							},300);
					}
					rv = true;
				}
				catch (ex) {}
				break;	
			case iface.EVENT_MOUSEUP_RIGHT:
				var panel = document.getElementById("widgetManager-menu");
				panel.openPopupAtScreen(aMouseX,aMouseY,true);
				rv = true;
				break;
			case iface.EVENT_HOTKEY:
				if (aParam == 12){
					try {
						if (favpart_widgetManager.hideAll){
							favpart_manager.showAll();
							favpart_widgetManager.hideAll = false;
						} else {
							favpart_manager.hideAll();
							favpart_widgetManager.hideAll = true;
						}
						rv = true;
					}
					catch (ex) {}
				} else if (aParam == 11){
					favpart_manager.doSearch();
				}
				break;				
		}
		
		return rv;
	},
	setFocusOnTrayIcon : function(){
		try {
			var trayIconController = this.getTrayIconController();
			trayIconController.setFocusToTrayIcon();
		} catch (e){
			this.reportError(e);
		}
	},
	sendBalloonMessageToTrayIcon : function(title,content) {
		try {
			var trayIconController = this.getTrayIconController();
			trayIconController.sendBalloonMessageToTrayIcon(title,content);
		} catch (e){
			this.reportError(e);
		}
	},
	addBoxForWin : function(aWin){
	    var box = document.createElement("button");
		box.setAttribute("class", "favpart-widget-thumbnail");
		box._win = aWin;
		return this.container.appendChild(box);
	},
	addBoxForArgs : function(args){
	    var box = document.createElement("button");
		box.setAttribute("class", "favpart-widget-thumbnail favpart-widget-thumbnail-notActivated");
		box._args = args;
		return this.container.appendChild(box);
	},
	updatePreview : function(aBox){
		try {
			if (aBox._win){
				if (aBox._win.closed){
					return;
				}
				aBox.setAttribute("label", aBox._win.document.title);
				aBox.setAttribute("tooltiptext", aBox._win.document.title);
				aBox.setAttribute("crop", "end");
				aBox.setAttribute("icon", aBox._win.widget.getIcon());
				if (aBox._win.widget.args) aBox.setAttribute("id", aBox._win.widget.args.id);
				aBox.setAttribute("name", aBox._win.name);
				var preview = aBox._win.widget.getThumbnail();
				if (preview == null) return;
				if (aBox.firstChild) {
				  if (aBox.firstChild == preview)
					return;
				  aBox.removeChild(aBox.firstChild);
				}
				aBox.appendChild(preview);
			} else if (aBox._args){
				aBox.setAttribute("label", aBox._args.name);
				aBox.setAttribute("tooltiptext", aBox._args.name);
				aBox.setAttribute("crop", "end");
				aBox.setAttribute("icon", aBox._args.iconUrl);
				aBox.setAttribute("id", aBox._args.id);
				aBox.setAttribute("name", aBox._args.name);
				var thumbnail =  document.createElementNS("http://www.w3.org/1999/xhtml", "canvas");
				thumbnail.mozOpaque = true;
				thumbnail.height = thumbnail_vars.height;
				thumbnail.width = thumbnail_vars.width;

				var ctx = thumbnail.getContext("2d");
				var img = new Image();
				img.onload = function(){
					ctx.drawImage(img,0,0);
				}
				if (aBox._args.thumbnail && aBox._args.thumbnail != ""){
					img.src = aBox._args.thumbnail;
				} else if (aBox._args.thumbUrl && aBox._args.thumbUrl != ""){
					img.src = aBox._args.thumbUrl;
				}
				if (thumbnail == null) return;
				if (aBox.firstChild) {
				  if (aBox.firstChild == thumbnail)
					return;
				  aBox.removeChild(aBox.firstChild);
				}
				aBox.appendChild(thumbnail);
				aBox.style.filter="url(#f2)";
			}
		} catch (e){
			this.reportError(e);
		}
	},
	scheduleUpdatePreviews : function(){
		if (this.updateTimer == null){ //first time.
			this.updatePreviews();
			this.updateTimer = 0;
		} else if (this.updateTimer == 0){
			var self = this;
			this.updateTimer = window.setTimeout(function(){self.updatePreviews(); self.updateTimer = 0;},1000);
		} else{
			//do nothing
		}
	},
	updatePreviews : function(){
		try {
			if (this.container == null) return;
			this.windowCount = 0;
			//delete all widgets preview cause menu flash
			while (this.container.hasChildNodes()){
				this.container.removeChild(this.container.firstChild);
			}
			
			
			var enumerator = wm.getEnumerator("mozilla:favpart_widget");
			while(enumerator.hasMoreElements()) {
				var win = enumerator.getNext();
				// |win| is [Object ChromeWindow] (just like |window|), do something with it
//				if (win.windowTools.hidden){
				this.windowCount++;
				this.updatePreview(this.addBoxForWin(win));
//				}
			}
			if (this.withAll){
				var results = favpart_manager.getAllWidgets();
				this.windowCount++;
			//	this.LOG(results);
				for (i in results){
				//	this.LOG(JSON.stringify(results[i]));
					var widget = results[i];
					if (document.getElementById(widget.id) == null){
						this.updatePreview(this.addBoxForArgs(widget));
					}
				}
			}
			if (this.windowCount == 0){
				document.getElementById("widgetPreview-container").style.display = "none";
			}else {
				document.getElementById("widgetPreview-container").style.display = "-moz-box";
			}
			this._reflow();
		} catch (e){
			this.reportError(e);
		}
	},
	_reflow : function() {
		try {
			if (document.getElementById("widgetPreview-container").style.display == "none"){return;}
	//		alert("I'm here again");
			this._updateControlButtons();

			// the size of the box relative to the preview image
			const REL_BOX_THUMBNAIL = 1.1;

		//	var maxHeight = this._maxHeight;
		//	var maxWidth = this._maxWidth;
			var rel = thumbnail_vars.height / thumbnail_vars.width;
			var columns, boxHeight, boxWidth, outerHeight;
			var boxMaxWidth = thumbnail_vars.width * REL_BOX_THUMBNAIL;
			boxWidth = boxMaxWidth;
			boxHeight = boxWidth * rel;
			columns = this.windowCount;
			this._boxLabelHeight = parseInt(getComputedStyle(this.container.firstChild, "").lineHeight);
			outerHeight = boxHeight + this._boxLabelHeight;

	//		this._columns = Math.floor(maxWidth / boxMaxWidth);
	//		do {
	//		  rows = Math.ceil(this._visible / this._columns);
	//		  boxWidth = Math.min(boxMaxWidth, Math.round(maxWidth / this._columns));
	//		  boxHeight = Math.round(boxWidth * rel);
		//	  outerHeight = boxHeight + this._boxLabelHeight;
	//		} while (rows * outerHeight > maxHeight && ++this._columns);

			var outerWidth = boxWidth;
			{
			  let innerWidth = Math.ceil(boxWidth / REL_BOX_THUMBNAIL);
			  let innerHeight = Math.ceil(boxHeight / REL_BOX_THUMBNAIL);
			  let verticalPadding = innerHeight * (REL_BOX_THUMBNAIL - 1);
			  var canvasStyle = "margin-bottom:" + (verticalPadding * .3) + "px;" +
								"max-width:" + innerWidth + "px;" +
								"min-width:" + innerWidth + "px;" +
								"max-height:" + innerHeight + "px;" +
								"min-height:" + innerHeight + "px;";
			}

			Array.forEach(this.container.childNodes, function (box) {
			  box.setAttribute("minwidth", outerWidth);
			  box.setAttribute("height", outerHeight);
			  box.setAttribute("canvasstyle", canvasStyle);
			  box.removeAttribute("closebuttonhover");
			}, this);
			var maxWidth = 210;
			var scrollbox = document.getElementById("widgetManager-container");
			var overflowed = scrollbox.getAttribute("overflowed");
			if (overflowed && overflowed == "true"){
				maxWidth = 226;
			} else {
				maxWidth = 210;
			}
//			this._stack.width = maxWidth;
//			this.container.width = maxWidth;
			this.container.left = 0;
//			this.container.maxWidth = maxWidth - this.container.left;
//			this.container.maxHeight = rows * outerHeight;
		} catch (e){
			this.reportError(e);
		}
	},
	pick : function (aBox){
	    if (!aBox) return;
		if (aBox) {
			if (aBox._win){
				aBox._win.windowTools.hidden = false;
				aBox._win.focus();
				this.updatePreviews();
				// in case that window gets on top of the menu
				this.hideMenu();
			} else {
		// start the widget
				favpart_manager.openWidget(aBox.id);
				// in case that window gets on top of the menu
				this.hideMenu();
			}
		}
	},
	hideMenu : function(){
	// hide the menu
		var panel = document.getElementById("widgetManager-menu");
		panel.hidePopup();
	},
	hiding : true,
	showAndHideManager : function (){
//		this.LOG(this.hiding);
//		monitor.LOG(control.style.opacity);
		if (this.hiding == true){
			if (window.screenX < window.screen.width -5){
//				this.LOG(window.screenX);
				window.moveTo(Math.min(window.screen.width - 5, window.screenX +20),150);
				window.setTimeout(function (){favpart_widgetManager.showAndHideManager();},20);
			}
		} else {
			if (window.screenX + window.outerWidth > window.screen.width + 2){
//				this.LOG(window.screenX);
				window.moveTo(Math.max(window.screen.width - window.outerWidth + 2, window.screenX - 20),150);
				window.setTimeout(function (){favpart_widgetManager.showAndHideManager();},20);
			}
		}
	},
	closeAll : function(){
		var enumerator = wm.getEnumerator("mozilla:favpart_widget");
		while(enumerator.hasMoreElements()) {
			var win = enumerator.getNext();
			// |win| is [Object ChromeWindow] (just like |window|), do something with it
			win.widget.args.startWithFirefox = 1;
			win.close();
		}
		window.close();
	},
	_updateControlButtons: function (event) {
		if (event && (event.target == this.controlButtons || event.target.parentNode == this.controlButtons))
		  return;

		if (this.controlButtons._targetBox) {
		  if (event && event.target == this.controlButtons._targetBox)
			return;

		  this.controlButtons._targetBox.removeAttribute("closebuttonhover");
		}

		if (event &&
			event.target.parentNode == this.container && event.target._win != null) {
//no buttons for unopened widgets
			let thumbnail = event.target.getBoundingClientRect();
			let container = this.container.getBoundingClientRect();
			this.controlButtons.left = thumbnail.left -
									 container.left +
									 parseInt(this.container.left) +
									  thumbnail.width -
									  this.controlButtons.boxObject.width;
			this.controlButtons.top = thumbnail.top -
									container.top;
			this.controlButtons._targetBox = event.target;
			this.controlButtons.style.visibility = "visible";
			event.target.setAttribute("closebuttonhover", "true");
		} else {
			this.controlButtons.style.visibility = "hidden";
			this.controlButtons.left = this.controlButtons.top = 0;
			this.controlButtons._targetBox = null;
		}
		this.updateControlButtonStates();
	},
	updateControlButtonStates: function () {
		if (!this.controlButtons._targetBox){
			return;
		}
		var targetWin = this.controlButtons._targetBox._win;
		this.windowLayerButton.state = targetWin.windowTools.windowLayer;
		this.windowLayerButton.setAttribute("state",targetWin.windowTools.windowLayer);
//		this.transButton.state = targetWin.windowTools.transparent;
//		this.transButton.setAttribute("state",targetWin.windowTools.transparent?"true":"false");
		this.hideWinButton.state = targetWin.windowTools.hidden;
		this.hideWinButton.setAttribute("state",targetWin.windowTools.hidden?"true":"false");
	},
	openBrowserWindow: function() {
		var win;
		var enumerator = wm.getEnumerator("navigator:browser");
		if(enumerator.hasMoreElements()) {
			win = enumerator.getNext();
			win.focus();
		} else {
			var handler = Components.classes["@mozilla.org/browser/clh;1"]
                          .getService(Components.interfaces.nsIBrowserHandler);
			var defaultArgs = handler.defaultArgs;
			win = window.openDialog("chrome://browser/content/", "_blank", "chrome,all,dialog=no", defaultArgs);
		}
	},
	rebuildMenu : function(){
		var ids = ["favorite-popup","channel-popup","video-popup","history-popup"];
		for (var i in ids){
			var pop = document.getElementById(ids[i]);
			pop.builder.rebuild();		
			if (pop.childElementCount <= 1){
				pop.parentNode.setAttribute("disabled","true");
			} else {
				pop.parentNode.setAttribute("disabled","false");
			}
		}
		this.rebuildFastLaunchPanel();
		this.updatePreviews();
		

	},
	
	rebuildFastLaunchPanel : function(){
				//rebuld fastLaunchPopup
		var popup = document.getElementById("fastLaunch-popup");
		//remove all widgets
		var nodes = popup.childNodes;
		for (var i=0; i < nodes.length;){
			if (nodes[i].tagName.toLowerCase() == "menuitem" || nodes[i].tagName.toLowerCase() == "menuseparator" || nodes[i].tagName.toLowerCase() == "vbox"){
				popup.removeChild(nodes[i]);
			} else {
				i++;
			}
		}
		//rebuild
		popup.builder.rebuild();
		
		var vbox = document.createElement("vbox");
		var menusep = document.createElement("menuseparator");
		vbox.appendChild(menusep);
		//add active widgets
		var enumerator = wm.getEnumerator("mozilla:favpart_widget");
		var winCount = 0;
		while (enumerator.hasMoreElements()) {
			win = enumerator.getNext();
			if (win.widget && win.widget.args && win.widget.args.widgetUrl && 
				(win.widget.args.widgetUrl == "chrome://livemargins/content/playerWindow.xul" ||
				 win.widget.args.widgetUrl == "chrome://livemargins/content/videoPlayer.xul")){
				var menu = document.createElement("menuitem");
				menu.setAttribute("label",win.widget.args.name);
				menu.setAttribute("tooltiptext",win.widget.args.name);
				menu.setAttribute("oncommand","favpart_openWidget( "+ win.widget.args.id +" );event.stopPropagation();");
				menu.setAttribute("image",win.widget.args.iconUrl);
				menu.setAttribute("class","menuitem-iconic");
				vbox.appendChild(menu);
				winCount ++;
			}
		}
		if (winCount > 0){
			popup.appendChild(vbox);
		}
		
		var menusep = document.createElement("menuseparator");
		popup.appendChild(menusep);
		var strbundle = document.getElementById("livemarginsStrings");
		var strLabel = strbundle.getString("more");
		var menu = document.createElement("menuitem");
		menu.setAttribute("label",strLabel);
		popup.appendChild(menu);
		menu.addEventListener("command",function(event){
				if (favpart_widgetManager.fastLaunchOpenFrom){
					var panel = document.getElementById('widgetManager-menu');
					panel.openPopupAtScreen(favpart_widgetManager.fastLaunchOpenFrom.x,favpart_widgetManager.fastLaunchOpenFrom.y,true);
				}else {
					
				}
				event.stopPropagation();
				event.preventDefault();
			},true);
	},
	restartFirefox : function(){
		var Application = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
		Application.restart();
	},
	semiMenupopup : function(e){
		var target = e.target;
		var relTarget = e.relatedTarget;
		var isInSubMenu = false;
		if (e.type == "mouseover"){
			//detect whether it's in a sub menu, if it is, do not close the menu, if not, close the menu, if it's not reaching the next menuitem or menu or button, etc, do nothing
			if (this.openedPopup && target.tagName != "vbox" && target.tagName != "menuseparator" && target.tagName != "panel"){
				var parent = target;
				while (parent != null && parent.parentNode != this.openedPopup){
					parent = parent.parentNode;
				}
				if (parent == null){//it's not in sub menu.
					if (target != this.lastNode){
						if(this.closeTimer) window.clearTimeout(this.closeTimer);
						this.closeTimer = window.setTimeout(function(){
							favpart_widgetManager.clearPopup();
						},this.hoverTime);
					}
				} else {
					window.clearTimeout(this.closeTimer);
					window.clearTimeout(this.openTimer);
					this.lastNode.removeAttribute('_moz-menuactive');
					this.openedPopup.parentNode.setAttribute('_moz-menuactive', true);
					this.lastNode = this.openedPopup.parentNode;
					isInSubMenu = true;
				}
			}
			// deal with the and open sub menu
			if (target.tagName == "menu"){
				target.setAttribute('_moz-menuactive', true);
				if (this.openTimer) window.clearTimeout(this.openTimer);
				if (target.getAttribute("disabled") != "true"){
					this.openTimer = window.setTimeout(function(){
							favpart_widgetManager.clearPopup();	
							target.menupopup.openPopup(target,'start_before',0,0,false,false);
							// this line is in case something happened with hidePopup...
							target.setAttribute('_moz-menuactive', true);
							favpart_widgetManager.openedPopup = target.menupopup;
						},this.hoverTime);
				}	
			}
			//If it's not in the sub menu, clean the highlight for lastNode and set highlight color for new item
			if (!isInSubMenu){
				if (this.lastNode){
					if (this.lastNode != target){
						if (this.lastNode.tagName != "menu"){
							this.lastNode.removeAttribute('_moz-menuactive');			
						} else {
							if (target.tagName == "menu" || target.tagName == "menuitem"){
								this.lastNode.removeAttribute('_moz-menuactive');
							}
						}
					}
				} 
				if (target.tagName == "menu" || target.tagName == "menuitem"){
					target.setAttribute('_moz-menuactive', true);
					this.lastNode = target;
				}
			}
			
		}
	},
	clearPopup : function(){
		if (this.openedPopup){
			this.openedPopup.hidePopup();
			this.openedPopup = null;
		}
	},
	openHelp : function(){
		this.openUrl("http://g-fox.cn/chinaedition/features/livemargins/");
	},
	openUrl : function(link){
		const wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
				.getService(Components.interfaces.nsIWindowMediator);
		var mainWin = wm.getMostRecentWindow( "navigator:browser" );
		if (mainWin) {
			mainWin.focus();
			var gBrowser = mainWin.getBrowser();
			gBrowser.selectedTab = gBrowser.addTab(link);
		} else {
			window.open(link);
		}
	},
	openOptions : function(){
		window.openDialog("chrome://livemargins/content/options.xul");
	},
	renameWidget : function(event){
		if (this.selectedHistory!= null){
			var widgetId = this.selectedHistory.getAttribute("wid");
			var label = this.selectedHistory.getAttribute("label");
			var ret = window.prompt("Enter new name for the widget.",label);
			if (ret != null && ret != "" &&ret != label){
				favpart_manager.renameWidget(widgetId,ret);
				//if the window is opening change the title
				var enumerator = wm.getEnumerator("mozilla:favpart_widget");  
				while(enumerator.hasMoreElements()) {  
					var win = enumerator.getNext();
					if (win.name == 'Favpart_widget_'+widgetId){
						win.widget.args.name = ret;
						win.document.title = ret;
					}
				}
			}
//			favpart_manager.renameWidget(widgetId,name);
		}
		this.selectedHistory = null;
		this.rebuildMenu();
	},	
	deleteWidget : function(event){
		if (this.selectedHistory!= null){
			var widgetId = this.selectedHistory.getAttribute("wid");
			favpart_manager.removeWidget(widgetId);
		}
		this.selectedHistory = null;
		this.rebuildMenu();
	},
	deleteAllFromMenu : function(event){
		if (this.selectedHistory == null) return;
		var siblings = this.selectedHistory.parentNode.childNodes;
		for (var i=0; i < siblings.length; i++){
			if (siblings[i].tagName.toLowerCase() == "menuitem"){
				var widgetId = siblings[i].getAttribute("wid");
				favpart_manager.removeWidget(widgetId);
			}
		}
		this.selectedHistory = null;
		this.rebuildMenu();
	},
	showAllWidgets : function(){
		favpart_manager.showAll();
		favpart_widgetManager.hideAll = false;
	},
	openFastLaunch : function(anchor,position,x,y){
		var popup = document.getElementById("fastLaunch-popup");
		popup.openPopup(anchor,position,x,y,true,false);
	},
	openMainMenu : function(anchor,position,x,y){
		var panel = document.getElementById("widgetManager-menu");
		panel.openPopup(anchor,position,x,y,false,false);
	},
	showAndHideAllWidgets : function(){
		if (favpart_widgetManager.hideAll){
			favpart_manager.showAll();
			favpart_widgetManager.hideAll = false;
		} else {
			favpart_manager.hideAll();
			favpart_widgetManager.hideAll = true;
		}
	}
};


function showManager(){
	favpart_widgetManager.hiding = false;
	window.setTimeout(function (){favpart_widgetManager.showAndHideManager();},favpart_widgetManager.showHideTimeout);
}
function hideManager(){
	favpart_widgetManager.hiding = true;
	window.setTimeout(function (){favpart_widgetManager.showAndHideManager();},favpart_widgetManager.showHideTimeout);
}
//window.addEventListener("mouseover",showManager,false);
//window.addEventListener("mouseout",hideManager,false);
window.addEventListener("load",function() {favpart_widgetManager.init();},false);
window.addEventListener("unload",function(event) {
		if (event.originalTarget == document) {
//			favpart_widgetManager.closeAll();
			favpart_widgetManager.uninit();
		}
	},true);
window.addEventListener("blur",function(event) {
		if (event.originalTarget == window){
			windowTools.hidden = true;
		}
	},true);

/*window.addEventListener("DOMContentLoaded",function(event) {
		window.removeEventListener("DOMContentLoaded",arguments.callee,true);
 		var searchbar = document.getElementById("searchbar");
		searchbar.handleSearchCommand = function(){
			var textBox = this._textbox;
			var textValue = textBox.value;
			var submission = this.currentEngine.getSubmission(textValue, null);
			var enumerator = wm.getEnumerator("navigator:browser");
			if(enumerator.hasMoreElements()) {
				win = enumerator.getNext();
				win.openUILinkIn(submission.uri.spec, 'tab', null, submission.postData);
				win.focus();
			} else {
				window.open(submission.uri.spec);
			}
		}
	},true); */
	
function favpart_openWidget(id){
	favpart_manager.openWidget(id);
}
