var windowTools = {
	debug : false,
	LOG : function(msg) {
		if (this.debug){
			try{
				var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
				consoleService.logStringMessage("FavPart: windowTools: " + msg);
			} catch(e){}
		}
	},
	_baseWindow : null,
	_windowModifier : null,
//0 is onDesktop, 1 is normal, 2 is onTop
	_windowLayer : 1,   //right for widget windows, but not for widgetManager
	_transparent : false,
	_transparency : 255,
	_onTaskbar : true,
	_hidden : false,
	getBaseWindow : function(){
		if (this._baseWindow == null){
			this._baseWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
					.getInterface(Components.interfaces.nsIWebNavigation)
					.QueryInterface(Components.interfaces.nsIDocShellTreeItem)
					.treeOwner
					.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
					.getInterface(Components.interfaces.nsIXULWindow)
					.docShell
					.QueryInterface(Components.interfaces.nsIBaseWindow);
		}
		return this._baseWindow;
	},
	getWindowModifier : function(){
		if (this._windowModifier == null) {
			this._windowModifier = Components.classes["@mozillaonline.com/windowmodifier;1"].createInstance();
			this._windowModifier = this._windowModifier.QueryInterface(Components.interfaces.IWindowModifier);
		}
		return this._windowModifier; 
	},
	get windowStates(){
		var winStates = {
			windowLayer : this.windowLayer,
//			transparent : this.transparent,
//			transparency : this.transparency,
			onTaskbar : this.onTaskbar,
//			hidden : this.hidden
		};
		return winStates;
	},
	set windowStates(winStates){
		if (winStates.windowLayer != null) this.windowLayer = winStates.windowLayer;
//		if (winStates.transparent != null) this.transparent = winStates.transparent;
//		if (winStates.transparency != null) this.transparency = winStates.transparency;
		if (winStates.onTaskbar != null) this.onTaskbar = winStates.onTaskbar;
//		if (winStates.hidden != null) this.hidden = winStates.hidden;
	},
	get windowLayer(){
		return this._windowLayer;
	},
	set windowLayer(windowLayer){
		this.LOG("setWindowLayer : " + windowLayer);
//		can not use next line, because can not detect whether the window is ontop by default
//		if (this._windowLayer == windowLayer) return;
		if (windowLayer == 0){
			this.setWindowOnDesktop();
		} else if (windowLayer == 1) {
			if (this._windowLayer == 2){
				this.setNoTopMost();
			} else if (this._windowLayer == 0){
				this.setWindowNotOnDesktop();
			}
		} else if (windowLayer == 2) {
			this.setTopMost();
		} else {
			this.LOG("windowLayer must be 0, 1 or 2");
		}
		this.sendUIEvent("windowLayerChanged");
	},
	get hidden(){
		this._hidden = !this.isWindowVisible();
		return this._hidden;
	},
	isWindowVisible : function(){
		var baseWindow = this.getBaseWindow();
		var windowModifier = this.getWindowModifier();
		var visible = windowModifier.isWindowVisible(baseWindow);
		return visible;	
	},
	set hidden(hidden){
//		if (this._hidden == hidden) return;
		if (this.isWindowVisible() == !hidden) return;
		this.setShow(!hidden);
		this.sendUIEvent("hiddenChanged");
	},
	get onTaskbar(){
		return this._onTaskbar;
	},
	set onTaskbar(onTaskbar){
		if (this._onTaskbar == onTaskbar) return;
		this.setWindowTaskbar(onTaskbar);
		this.sendUIEvent("onTaskbarChanged");
	},
	get transparent(){
		return this._transparent;
	},
	set transparent(transparent){
		if (this._transparent == transparent) return;
		if (transparent){
			if (this._transparency == 255){
				this._transparency = 160;
			}
			if (this.setTransparency(this._transparency)){
				this._transparent = true;
			} else {
// set transparency return false, means you cannot set transparency for this window, no transparentChanged event send.
				this._transparent = false;
				return;
			}
		} else {
			if (this.setTransparency(255)){
				this._transparent = false;
			} else {
				this._transparent = false;
				
			}
		}
		this.sendUIEvent("transparentChanged");
	},
	get transparency(){
		return this._transparency;
	},
	set transparency(transparency){
		if (this._transparency == transparency) return;
		this._transparency = transparency;
		if (this._transparent){
			this.setTransparency(this._transparency);
		}
		this.sendUIEvent("transparencyChanged");
	},
	setWindowOnDesktop : function() {
		try {
			if (this._windowLayer = 2){
				this.setNoTopMost();
			}
			var baseWindow = this.getBaseWindow();
			var windowModifier = this.getWindowModifier();
			windowModifier.setWindowOnDesktop(baseWindow);
			this._windowLayer = 0;
		} catch (e) {
			this.LOG(e.toString());
		}
	},
	setWindowNotOnDesktop : function() {
		try {
			var baseWindow = this.getBaseWindow();
			var windowModifier = this.getWindowModifier();
			windowModifier.setWindowNotOnDesktop(baseWindow);
			this._windowLayer = 1;
		} catch (e) {
			this.LOG(e.toString());
		}
	},
	setTopMost : function(){
		try {
			if (this._windowLayer == 0 ){
				this.setWindowNotOnDesktop();
			}
			var baseWindow = this.getBaseWindow();
			var windowModifier = this.getWindowModifier();
			windowModifier.setWindowTopMost(baseWindow);
			this._windowLayer = 2;
		} catch (e) {
			this.LOG(e.toString());
		}
	},
	setNoTopMost : function() {
		try {
			var baseWindow = this.getBaseWindow();
			var windowModifier = this.getWindowModifier();
			windowModifier.setWindowNoTopMost(baseWindow);
			//windowModifier.setWindowOnDesktop(baseWindow);
			this._windowLayer = 1;
		} catch (e) {
			this.LOG(e.toString());
		}
	},
	setTransparency : function(transparency) {
		try {
			var baseWindow = this.getBaseWindow();
			var windowModifier = this.getWindowModifier();
			var retval = windowModifier.setWindowTransparency(baseWindow,transparency);
			if (retval == false) {
				this.LOG("setTransparency: your window maybe transparent background, do not try to use this function to set transparency, it will mess up what firefox does, overwrite this function, and create your own using opacity kinda stuff.");
			}
			return retval;
		} catch (e) {
			this.LOG(e.toString());
		}
	},
	setRoundRgn : function(width,height) {
		if (width == null){
			width = 10;
		}
		if (height == null){
			height = 10;
		}
		try {
			var baseWindow = this.getBaseWindow();
			var windowModifier = this.getWindowModifier();
			windowModifier.setWindowRoundRgn(baseWindow,width,height);
		} catch (e) {
			this.LOG(e.toString());
		}
	},
	setWindowTaskbar : function(onTaskbar) {
		try {
			this.LOG("set taskbar");
			var baseWindow = this.getBaseWindow();
			var windowModifier = this.getWindowModifier();
			windowModifier.setWindowTaskbar(baseWindow,onTaskbar);
			this._onTaskbar = onTaskbar;
		} catch (e) {
			this.LOG(e.toString());
		}
	},
	setShow : function(show) {
		try {
			this.LOG("setShow " + show);
			var baseWindow = this.getBaseWindow();
			var windowModifier = this.getWindowModifier();
			windowModifier.setWindowShow(baseWindow,show);
			this._hidden = !show;
		} catch (e) {
			this.LOG(e.toString());
		}
	},
	sendUIEvent : function(type,detail) {
		try{
			if (detail == null) detail = 0;
			e = document.createEvent("UIEvents");
			e.initUIEvent(type, true, true, window, detail);
			window.dispatchEvent(e);
		} catch (e){
			this.LOG(e.toString());
		}
	}
};
