var EXPORTED_SYMBOLS = ["favpart_manager","thumbnail_vars"];
var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);  
var window = wm.getMostRecentWindow("navigator:browser");
var bookmarkBaseURL = "chrome://livemargins/content/bookmark.html";
var Application = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
Components.utils.import("resource://livemargins/searchService.js"); 
Components.utils.import("resource://livemargins/grabpic.js"); 

if (typeof JSON === 'undefined' || JSON == null) { //this is for version lower than 3.5
	Components.utils.import("resource://livemargins/json2.js"); 
}
var SEARCH_WIDGET_ID = 1; // do not change this, will cause errors until you delete the database.
var PIC_WIDGET_ID = 2;	//do not change this, will cause errors until you delete the database.
var WEATHER_WIDGET_ID = 3;	//do not change this, will cause errors until you delete the database.
var MUSIC_WIDGET_ID = 4; //do not change this, will cause errors until you delete the database.
var favpart_manager = {
	dbConn : null,
	widgetManagerWin : null,
	debug : false,
	TIMES_VISITED_TO_SET_BOOKMARK : 10,
	HISTORY_COUNT : 10,
	dbFilename : "favpart_manager_2.9.0.sqlite",
	searchWin : null,
	playerMinWidth : 160,
	playerMinHeight : 90,
	POS_NOT_SET : 9999,
	LOG : function(msg) {
		if (this.debug){
			try{
				var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
				consoleService.logStringMessage("FavParts: manager: " + msg);
			} catch(e){}
		}
	},
	getPref : function(prefName, defValue){
		try {
			this.LOG("getPref");
			var prefs = Application.extensions.get("livemargins@mozillaonline.com").prefs;
			this.LOG("getPref: " + prefs);
			return prefs.getValue(prefName,defValue);
		} catch (e) {
			Components.utils.reportError(e);
		}
	},
	getPrefFromRoot : function(prefName, defValue){
		try {
			this.LOG("getPref");
			var prefs = Application.prefs;
			this.LOG("getPref: " + prefs);
			return prefs.getValue(prefName,defValue);
		} catch (e) {
			Components.utils.reportError(e);
		}
	},
	setPref : function(prefName, value){
		try {
			this.LOG("setPref");
			var prefs = Application.extensions.get("livemargins@mozillaonline.com").prefs;
			this.LOG("setPref: " + prefs);
			return prefs.setValue(prefName,value);
		} catch (e) {
			Components.utils.reportError(e);
		}
	},
	reportError : function(error){
		try {
			if(this.debug){
				Components.utils.reportError(error);
			}
		} catch (e){
			Components.utils.reportError(e);
		}
	},
	/*
	*  create database if not exist alreay.
	*/
	init : function(){
		this.LOG("init");
		if (this.dbConn == null){
			this.findWindow();
			var file = Components.classes["@mozilla.org/file/directory_service;1"]  
							.getService(Components.interfaces.nsIProperties)  
							.get("ProfD", Components.interfaces.nsIFile);  
			file.append(this.dbFilename);
			if (!file.exists() || file.fileSize == 0){
				var storageService = Components.classes["@mozilla.org/storage/service;1"]  
								   .getService(Components.interfaces.mozIStorageService);  
				this.dbConn = storageService.openDatabase(file); // Will also create the file if it does not exist  
				var strbundle = Components.classes["@mozilla.org/intl/stringbundle;1"].
						getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://livemargins/locale/livemargins.properties");
				var searchName = strbundle.GetStringFromName("search.name");
				var tvName = strbundle.GetStringFromName("tv.name");
				var musicName = strbundle.GetStringFromName("music.name");
				var radioName = strbundle.GetStringFromName("radio.name");
				var stockName = strbundle.GetStringFromName("stock.name");
				var weatherName = strbundle.GetStringFromName("weather.name");
				var taobaoName = strbundle.GetStringFromName("taobao.name");
				var picName = strbundle.GetStringFromName("pic.name");
				var screenX = window.screen.availWidth - 350;
				var screenY = window.screen.availHeight - 600;
				this.dbConn.executeSimpleSQL("CREATE TABLE widgets (id INTEGER PRIMARY KEY, name VARCHAR(32), widgetUrl VARCHAR(1024), widgetArgs VARCHAR(2048), screenX INTEGER, screenY INTEGER, timeAdd TIME, timeMod TIME, lastOpen TIME, bookmark TINYINT(1) DEFAULT 0, startWithFirefox TINYINT(1) DEFAULT 0, channel TINYINT(1) DEFAULT 0, windowStates VARCHAR(1024), thumbnail BLOB, thumbUrl VARCHAR(1024), iconUrl VARCHAR(1024), timesVisited INTEGER DEFAULT 0);");
//create initial favorites(channels)
				this.dbConn.executeSimpleSQL("INSERT INTO widgets(id,name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ("+ SEARCH_WIDGET_ID +",'"+searchName+"','chrome://livemargins/content/searchWidget.xul','null',"+this.POS_NOT_SET+","+this.POS_NOT_SET+",'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','chrome://livemargins/skin/search-icon.png');");
				this.dbConn.executeSimpleSQL("INSERT INTO widgets(id,name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ("+ PIC_WIDGET_ID +",'"+picName+"','chrome://livemargins/content/picWidget.xul','null',"+this.POS_NOT_SET+","+this.POS_NOT_SET+",'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','chrome://livemargins/skin/pic-icon.png');");
				this.dbConn.executeSimpleSQL("INSERT INTO widgets(id,name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ("+ WEATHER_WIDGET_ID +",'"+weatherName+"','chrome://livemargins/content/weatherWidget.xul','null',"+this.POS_NOT_SET+","+this.POS_NOT_SET+",'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','chrome://livemargins/skin/weather-icon.png');");
				this.dbConn.executeSimpleSQL("INSERT INTO widgets(id,name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ("+ MUSIC_WIDGET_ID +",'"+musicName+"','chrome://livemargins/content/musicWidget.xul','null',"+screenX+","+screenY+",'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','chrome://livemargins/skin/music-icon.png');");
				this.dbConn.executeSimpleSQL("INSERT INTO widgets(name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ('"+tvName+"','chrome://livemargins/content/videoWidget.xul','null',"+screenX+","+screenY+",'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','chrome://livemargins/skin/tv-icon.png');");
				//this.dbConn.executeSimpleSQL("INSERT INTO widgets(name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ('SMGBB TV','chrome://livemargins/content/playerWindow.xul','{\"location\":\"http://www.smgbb.cn/firefox/firefox.swf\",\"docX\":1,\"docY\":1,\"width\":298,\"height\":271,\"browserWidth\":301,\"browserHeight\":270,\"zoom\":1}',20,20,'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','moz-anno:favicon:http://fffocus.cn/favicon.ico');");
				//this.dbConn.executeSimpleSQL("INSERT INTO widgets(name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ('Stock','chrome://livemargins/content/playerWindow.xul','{\"location\":\"http://fffocus.cn/w98/stock/stockC/finance.jsp\",\"docX\":4,\"docY\":4,\"width\":295,\"height\":286,\"browserWidth\":301,\"browserHeight\":680,\"zoom\":1}',20,20,'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','moz-anno:favicon:http://fffocus.cn/favicon.ico');");
				this.dbConn.executeSimpleSQL("INSERT INTO widgets(name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ('"+stockName+"','chrome://livemargins/content/stockWidget.xul','null',"+this.POS_NOT_SET+","+this.POS_NOT_SET+",'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','chrome://livemargins/skin/stock-icon.png');");
				this.dbConn.executeSimpleSQL("INSERT INTO widgets(name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ('"+taobaoName+"','chrome://livemargins/content/taobaoWidget.xul','null',"+this.POS_NOT_SET+","+this.POS_NOT_SET+",'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','chrome://livemargins/skin/taobao-icon.png');");
				this.dbConn.executeSimpleSQL("INSERT INTO widgets(name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ('"+radioName+"','chrome://livemargins/content/radioWidget.xul','null',"+this.POS_NOT_SET+","+this.POS_NOT_SET+",'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','chrome://livemargins/skin/radio-icon.png');");
				
//this one is for test porpose only
				//this.dbConn.executeSimpleSQL("INSERT INTO widgets(name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ('demo Name','chrome://livemargins/content/demoWidget.xul','null',0,0,'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','chrome://livemargins/skin/transformer.png','chrome://livemargins/skin/sissors.png');");
				
				this.setPref("lastVer","3.0.5");
			} else {
				var storageService = Components.classes["@mozilla.org/storage/service;1"]  
								   .getService(Components.interfaces.mozIStorageService);  
				this.dbConn = storageService.openDatabase(file); // Will also create the file if it does not exist  

				var lastVer = this.getPref("lastVer","0.1.0");
				if (lastVer < "3.0.2"){
					//update channel widget names
					try {
						var statement = this.dbConn.createStatement("SELECT * FROM widgets WHERE widgetUrl='chrome://livemargins/content/searchWidget.xul';");
						var wrapper = Components.classes["@mozilla.org/storage/statement-wrapper;1"].
							createInstance(Components.interfaces.mozIStorageStatementWrapper);
						wrapper.initialize(statement);
						wrapper.reset();
						wrapper.step();
						var strbundle = Components.classes["@mozilla.org/intl/stringbundle;1"].
								getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://livemargins/locale/livemargins.properties");
						var searchName = strbundle.GetStringFromName("search.name");
						var tvName = strbundle.GetStringFromName("tv.name");
						var musicName = strbundle.GetStringFromName("music.name");
						var stockName = strbundle.GetStringFromName("stock.name");
						var weatherName = strbundle.GetStringFromName("weather.name");
						var taobaoName = strbundle.GetStringFromName("taobao.name");
						var picName = strbundle.GetStringFromName("pic.name");
						if (wrapper.row.name != searchName){
							this.dbConn.executeSimpleSQL("UPDATE widgets SET name='" + searchName +"' WHERE widgetUrl='chrome://livemargins/content/searchWidget.xul'");
							this.dbConn.executeSimpleSQL("UPDATE widgets SET name='" + tvName +"' WHERE widgetUrl='chrome://livemargins/content/videoWidget.xul'");
							this.dbConn.executeSimpleSQL("UPDATE widgets SET name='" + musicName +"' WHERE widgetUrl='chrome://livemargins/content/musicWidget.xul'");
							this.dbConn.executeSimpleSQL("UPDATE widgets SET name='" + stockName +"' WHERE widgetUrl='chrome://livemargins/content/stockWidget.xul'");
							this.dbConn.executeSimpleSQL("UPDATE widgets SET name='" + weatherName +"' WHERE widgetUrl='chrome://livemargins/content/weatherWidget.xul'");
							this.dbConn.executeSimpleSQL("UPDATE widgets SET name='" + taobaoName +"' WHERE widgetUrl='chrome://livemargins/content/taobaoWidget.xul'");
							this.dbConn.executeSimpleSQL("UPDATE widgets SET name='" + picName +"' WHERE widgetUrl='chrome://livemargins/content/picWidget.xul'");
							this.setPref("lastVer","3.0.2");
						}
						wrapper.statement.finalize();
					} catch (e){
						this.reportError(e);
						if (wrapper) wrapper.statement.finalize();
					}
					
				}
				
				lastVer = this.getPref("lastVer","0.1.0");
				if (lastVer < "3.0.5"){
					try {
						var statement = this.dbConn.createStatement("SELECT * FROM widgets WHERE widgetUrl='chrome://livemargins/content/radioWidget.xul';");
						var wrapper = Components.classes["@mozilla.org/storage/statement-wrapper;1"].
							createInstance(Components.interfaces.mozIStorageStatementWrapper);
						wrapper.initialize(statement);
						wrapper.reset();
						if (!wrapper.step()){//no such line
							var strbundle = Components.classes["@mozilla.org/intl/stringbundle;1"].
								getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://livemargins/locale/livemargins.properties");
							var radioName = strbundle.GetStringFromName("radio.name");
							this.dbConn.executeSimpleSQL("INSERT INTO widgets(name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,channel,thumbnail,thumbUrl,iconUrl) values ('"+radioName+"','chrome://livemargins/content/radioWidget.xul','null',"+this.POS_NOT_SET+","+this.POS_NOT_SET+",'null',datetime('now'),datetime('now'),datetime('now'),0,0,1,'','','chrome://livemargins/skin/radio-icon.png');");
						}
						wrapper.statement.finalize();
						this.setPref("lastVer","3.0.5");
					} catch (e){
						this.reportError(e);
						if (wrapper) wrapper.statement.finalize();
					}
				}
				this.cleanHistory(this.HISTORY_COUNT);
			}
			SearchService.init();
			GrabPicturesService.initService();
		}
		var count = 0;
		var enumerator = wm.getEnumerator("mozilla:favpart_widget");
		while(enumerator.hasMoreElements()) {
			var win = enumerator.getNext();
			count++;
		}
		if (count == 0){
			this.openStartWithFirefox();
		}
		this.openWidgetManager();
	},
	findWindow : function(){
		if (window == null || window.closed){
			window = wm.getMostRecentWindow("navigator:browser");
			if (window == null){
				window = wm.getMostRecentWindow("");
			}
		}
	},
	raiseWidget : function(args) {
		this.LOG(args);
		this.findWindow();
//,popup=yes,alwaysRaised=yes is for windows_nt platform to place the window on top 
		var winFeatures = "chrome,all,dialog=no";
		if (window.navigator.appVersion.indexOf("Mac") == -1){//Mac will not paint window out of screen
			if (args.screenX) {winFeatures +=",left="+args.screenX;}
			if (args.screenY) {winFeatures +=",top="+args.screenY;}
		} else {
			if (args.screenX == this.POS_NOT_SET){
				winFeatures +=",left="+Math.max(window.screen.availWidth - 300,0);
				winFeatures +=",top="+Math.max(window.screen.availHeight - 400,0);
			}else {
	            if (args.screenX) {winFeatures +=",left="+args.screenX;}
                if (args.screenY) {winFeatures +=",top="+args.screenY;}
			}
		}
//check whether the window with the same id already exist, if exist, focus, else, raise
		var enumerator = wm.getEnumerator("mozilla:favpart_widget");  
		while(enumerator.hasMoreElements()) {  
			var win = enumerator.getNext();
			if (win.name == 'Favpart_widget_'+args.id){
				win.focus();
				return;
			}
		}
		
		var widgetWindow = window.openDialog(args.widgetUrl, 'Favpart_widget_'+args.id, winFeatures,args);
		return widgetWindow;
	},
	raiseWidgetManager : function() {
		this.findWindow();
		var winFeatures = 'chrome,all,dialog=no';
		if (window.navigator.appVersion.indexOf('Mac') != -1){
			winFeatures += ',left=1,top=1'
		}
		var managerWindow = window.openDialog('chrome://livemargins/content/widgetManager.xul', 'Favpart_widget_manager', 'chrome,all,dialog=no');
		return managerWindow;
	},
	/*
	* if succeed, return id.
	*/
	addWidget : function(name,widgetUrl, widgetArgs, screenX, screenY, windowStates,thumbnail, thumbUrl,iconUrl) {
		try {
			if (typeof(widgetArgs) != "string") widgetArgs = JSON.stringify(widgetArgs);
			if (typeof(windowStates) != "string") windowStates = JSON.stringify(windowStates);
			if (screenX == null) screenX = 20;
			if (screenY == null) screenY = 20;
//sql use ' as escape character
			var sql = "INSERT INTO widgets(name,widgetUrl,widgetArgs,screenX,screenY,windowStates,timeAdd,timeMod,lastOpen,bookmark,startWithFirefox,thumbnail,thumbUrl,iconUrl,timesVisited)\
						values (:name,:widgetUrl,:widgetArgs,:screenX,:screenY,:windowStates,datetime('now'),datetime('now'),datetime('now'),:bookmark,:startWithFirefox,:thumbnail,:thumbUrl,:iconUrl,0)";
			var stmt = this.dbConn.createStatement(sql);
			stmt.params.name = name;
			stmt.params.widgetUrl = widgetUrl;
			stmt.params.widgetArgs = widgetArgs;
			stmt.params.screenX = screenX;
			stmt.params.screenY = screenY;
			stmt.params.windowStates = windowStates;
			stmt.params.bookmark = 0;
			stmt.params.startWithFirefox = 0;
			stmt.params.thumbnail = thumbnail?thumbnail:"";
			stmt.params.thumbUrl = thumbUrl?thumbUrl:"";
			stmt.params.iconUrl = iconUrl?iconUrl:"";
			stmt.execute();
			stmt.finalize();
			return this.dbConn.lastInsertRowID;
		} catch (e){
			this.reportError(e);
			stmt.finalize();
			return null;		
		}
	},
	addFavpart : function(name, location, docX, docY, screenX, screenY, width, height, browserWidth, browserHeight, zoom){
		try {
			if (zoom == null) zoom = 1;
			var widgetUrl = "chrome://livemargins/content/playerWindow.xul";
			var widgetArgs = {
				location : location,
				docX : docX,
				docY : docY,
				width : width,
				height : height,
				browserWidth : browserWidth,
				browserHeight : browserHeight,
				zoom : zoom,
			};
			var id = this.addWidget(name,widgetUrl,widgetArgs,screenX,screenY,null,null,null,null);
			if (id == null) return;
			var args = {
					id: id,
					name : name,
					widgetUrl : widgetUrl,
					widgetArgs : widgetArgs,
					screenX : screenX,
					screenY : screenY,
					windowStates : null
			};
			var playerWindow = this.raiseWidget(args);
//			this.openWidgetManager();
		} catch (e){
			this.reportError(e);
			return null;
		}
		return id;
	},
	addVideoPlayer : function(name, location, docX, docY, screenX, screenY, width, height, browserWidth, browserHeight,tagName, elementIndex, elementWidth,elementHeight){
		try {
			var widgetUrl = "chrome://livemargins/content/videoPlayer.xul";
			var widgetArgs = {
				location : location,
				docX : docX,
				docY : docY,
				width : width,
				height : height,
				browserWidth : browserWidth,
				browserHeight : browserHeight,
				tagName : tagName,
				elementIndex : elementIndex,
				elementWidth : elementWidth,
				elementHeight : elementHeight,
			};
			var id = this.addWidget(name,widgetUrl,widgetArgs,screenX,screenY,null,null,null,null);
			if (id == null) return;
			var args = {
					id: id,
					name : name,
					widgetUrl : widgetUrl,
					widgetArgs : widgetArgs,
					screenX : screenX,
					screenY : screenY,
					windowStates : null
			};
			var playerWindow = this.raiseWidget(args);
//			this.openWidgetManager();
		} catch (e){
			this.reportError(e);
			return null;
		}
		return id;
	},
	getWidget : function (id){
		try {
			var statement = this.dbConn.createStatement("SELECT * FROM widgets WHERE id="+id+";");
			var wrapper = Components.classes["@mozilla.org/storage/statement-wrapper;1"].
					createInstance(Components.interfaces.mozIStorageStatementWrapper);
			wrapper.initialize(statement);
			var result = null;
			try {
				if (wrapper.step()){
					result = {
						id : wrapper.row.id,
						name : wrapper.row.name,
						widgetUrl : wrapper.row.widgetUrl,
						widgetArgs : JSON.parse(wrapper.row.widgetArgs),
						screenX : wrapper.row.screenX,
						screenY : wrapper.row.screenY,
						timeAdd : wrapper.row.timeAdd,
						timeMod : wrapper.row.timeMod,
						lastOpen : wrapper.row.lastOpen,					
						bookmark : wrapper.row.bookmark,
						startWithFirefox : wrapper.row.startWithFirefox,
						windowStates : JSON.parse(wrapper.row.windowStates),
						thumbnail : wrapper.row.thumbnail,
						thumbUrl : wrapper.row.thumbUrl,
						iconUrl : wrapper.row.iconUrl,
						timesVisited : wrapper.row.timesVisited
					};
				}
			} finally {
				wrapper.statement.finalize();
			}
			return result;
		} catch (e){
			this.reportError(e);
			return null;
		}
	},
	findFavpart : function (location,docX,docY,width,height,browserWidth,browserHeight,zoom){
		try {
			var widgetUrl = "chrome://livemargins/content/playerWindow.xul";
			var widgetArgs = {
				location : location,
				docX : docX,
				docY : docY,
				width : width,
				height : height,
				browserWidth : browserWidth,
				browserHeight : browserHeight,
				zoom : zoom,
			};
			return this.findWidget(widgetUrl,widgetArgs);
		} catch (e){
			this.reportError(e);
			return null;
		}
	},
	findWidget : function (widgetUrl,widgetArgs){
		try {
			var statement = this.dbConn.createStatement("SELECT * FROM widgets WHERE widgetUrl='" + widgetUrl +"'" +
														" AND widgetArgs = :widgetArgs;");
			var wrapper = Components.classes["@mozilla.org/storage/statement-wrapper;1"].
					createInstance(Components.interfaces.mozIStorageStatementWrapper);
			wrapper.initialize(statement);
			wrapper.params.widgetArgs = JSON.stringify(widgetArgs);
			var result = null;
			try {
				if (wrapper.step()){
					result = {
						id : wrapper.row.id,
						name : wrapper.row.name,
						widgetUrl : wrapper.row.widgetUrl,
						widgetArgs : JSON.parse(wrapper.row.widgetArgs),
						screenX : wrapper.row.screenX,
						screenY : wrapper.row.screenY,
						timeAdd : wrapper.row.timeAdd,
						timeMod : wrapper.row.timeMod,
						lastOpen : wrapper.row.lastOpen,					
						bookmark : wrapper.row.bookmark,
						startWithFirefox : wrapper.row.startWithFirefox,
						windowStates : JSON.parse(wrapper.row.windowStates),
						thumbnail : wrapper.row.thumbnail,
						thumbUrl : wrapper.row.thumbUrl,
						iconUrl : wrapper.row.iconUrl,
						timesVisited : wrapper.row.timesVisited
					};
				}
			} finally {
				wrapper.statement.finalize();
			}
			return result;
		} catch (e){
			this.reportError(e);
			return null;
		}
	},
	openWidget : function (id){
		try {
			var result = this.getWidget(id);
			if (result == null){
				this.LOG("no favpart with given id.");
				return;
			}
			var playerWindow = this.raiseWidget(result);
			return playerWindow;
//			this.openWidgetManager();
		} catch (e){
			this.reportError(e);
		}
	},
	openWidgetManager : function (){
		this.LOG("openWidgetManager")
		if (this.widgetManagerWin == null || this.widgetManagerWin.closed){
			this.widgetManagerWin = this.raiseWidgetManager();
		}
		return this.widgetManagerWin;
	},
	getWidgetManager : function (){
		this.LOG("openWidgetManager")
		if (this.widgetManagerWin == null || this.widgetManagerWin.closed){
			this.widgetManagerWin = this.raiseWidgetManager();
		}
		return this.widgetManagerWin;
	},
	removeWidget : function (id){
		try {
			this.dbConn.executeSimpleSQL("DELETE FROM widgets WHERE id='" + id +"';");
		} catch (e){
			this.reportError(e);
		}
	},
/*
* this function add bookmark to firefox bookmark system, add it to favpart folder, with the bookmark.html and the param of name, location, docX, docY, width, height, browserWidth, browserHeight and zoom
*/
	addBookmark:function (id){
		try {
			//this.LOG(id);
			var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"]
                      .getService(Components.interfaces.nsINavBookmarksService);
			var bookmarkMenu = bmsvc.bookmarksMenuFolder;
			var favpartFolder = bmsvc.getChildFolder(bookmarkMenu,"FAVORITE PART");
			if (favpartFolder == 0){
				favpartFolder = bmsvc.createFolder(bookmarkMenu,"FAVORITE PART",-1);
			}
			if (!this.findBookmark(id)){
				var args = this.getWidget(id);
				this.bookmarkedWidgets.push(args);
				this.LOG(favpartFolder);
				var ios = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
				var uri = ios.newURI(bookmarkBaseURL+"?name="+escape(args.name)+
										"&widgetUrl="+escape(args.widgetUrl)+
										"&widgetArgs="+escape(JSON.stringify(args.widgetArgs)), null, null);
				bmsvc.insertBookmark(favpartFolder , uri, 
										-1, "FAVORITE PART - " + args.name);
			}
			this.dbConn.executeSimpleSQL("UPDATE widgets SET bookmark = 1 where id='" +id+ "';");
		} catch (e){
		
			this.reportError(e);
		}
	},
	findBookmark : function (id){
//		this.LOG(id);
		var args = this.getWidget(id);
		var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"]
                      .getService(Components.interfaces.nsINavBookmarksService);
		var ios = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
		var uri = ios.newURI(bookmarkBaseURL+"?name="+escape(args.name)+
										"&widgetUrl="+escape(args.widgetUrl)+
										"&widgetArgs="+escape(JSON.stringify(args.widgetArgs)), null, null);
		var bookmarksArray = bmsvc.getBookmarkIdsForURI(uri, {});
		if (bookmarksArray.length == 0){
			return 0;
		} else {
			return bookmarksArray[0];
		}
	},
	modifyBookmark : function (args){
		var bookmark = this.findBookmark(args.id);
		if (!bookmark) return;
		var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"]
                .getService(Components.interfaces.nsINavBookmarksService);
				var ios = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
		var uri = ios.newURI(bookmarkBaseURL+"?name="+escape(args.name)+
										"&widgetUrl="+escape(args.widgetUrl)+
										"&widgetArgs="+escape(JSON.stringify(args.widgetArgs)), null, null);
		bmsvc.changeBookmarkURI(bookmark, uri);
	},
/*	toggleBookmark : function (id){
		try {
			this.dbConn.executeSimpleSQL("UPDATE widgets SET bookmark=abs(bookmark-1) where id='" +id+ "';");
		} catch (e){
			this.reportError(e);
		}
	},*/
	setBookmark : function (id, value){
		try {
			this.dbConn.executeSimpleSQL("UPDATE widgets SET bookmark=" + value + " where id='" +id+ "';");
		} catch (e){
			this.reportError(e);
			this.LOG(id);
		}
	},
	renameWidget : function (id, name){
		try {
			var sql = "UPDATE widgets SET name=:name where id=:id;"
			var stmt = this.dbConn.createStatement(sql);
			stmt.params.name = name;
			stmt.params.id = id;
			stmt.execute();
			stmt.finalize();
		} catch (e){
			this.reportError(e);
			if (stmt)stmt.finalize();
			this.LOG(id);
		}
	},
	toggleStartWithFirefox : function (id){
		try {
			this.dbConn.executeSimpleSQL("UPDATE widgets SET startWithFirefox=abs(startsWithFirefox-1) where id='" +id+ "';");
		} catch (e){
			this.reportError(e);
		}
	},
	setStartWithFirefox : function (id, value){
		try {
			this.dbConn.executeSimpleSQL("UPDATE widgets SET startWithFirefox="+ value +" where id='" +id+ "';");
		} catch (e){
			this.reportError(e);
		}
	},
	cleanHistory : function ( leftCount){
		try {
			this.LOG("cleanHistory");
//			this.dbConn.executeSimpleSQL("UPDATE widgets SET bookmark = 1 WHERE bookmark = 0 AND timesVisited >=" + this.TIMES_VISITED_TO_SET_BOOKMARK + ";");
			this.dbConn.executeSimpleSQL("DELETE FROM widgets WHERE id IN (SELECT id FROM widgets WHERE startWithFirefox=0 AND bookmark=0 AND channel=0 ORDER BY timeAdd desc limit "+leftCount+",(select count(*) from widgets));");
		} catch (e){
			this.reportError(e);
		}
	},
	openStartWithFirefox : function (){
		this.LOG("startWithFirefox")
		var statement = this.dbConn.createStatement("SELECT * FROM widgets WHERE startWithFirefox=1;");
		var wrapper = Components.classes["@mozilla.org/storage/statement-wrapper;1"].
                createInstance(Components.interfaces.mozIStorageStatementWrapper);
		wrapper.initialize(statement);
		var hasWindow = false;
		try {
			wrapper.reset();
			while(wrapper.step()){
				this.LOG("Loop1:"+wrapper.row.id+","+wrapper.row.name+","+wrapper.row.widgetArgs);
				hasWindow = true;
				let result = {
						id : wrapper.row.id,
						name : wrapper.row.name,
						widgetUrl : wrapper.row.widgetUrl,
						widgetArgs : JSON.parse(wrapper.row.widgetArgs),
						screenX : wrapper.row.screenX,
						screenY : wrapper.row.screenY,
						timeAdd : wrapper.row.timeAdd,
						timeMod : wrapper.row.timeMod,
						lastOpen : wrapper.row.lastOpen,					
						bookmark : wrapper.row.bookmark,
						startWithFirefox : wrapper.row.startWithFirefox,
						windowStates : JSON.parse(wrapper.row.windowStates),
						thumbnail : wrapper.row.thumbnail,
						thumbUrl : wrapper.row.thumbUrl,
						iconUrl : wrapper.row.iconUrl,
						timesVisited : wrapper.row.timesVisited
					};
//				this.LOG("Loop2:"+wrapper.row.id+","+wrapper.row.name+","+wrapper.row.location);
				var playerWindow = this.raiseWidget(result);
			}
		} finally {
			wrapper.statement.finalize();
		}
//		if (hasWindow) this.openWidgetManager();
	},
	//return all the args 
	getAllWidgets : function(){
		this.LOG("getAllBookmarkedWidgets");
//		if (this.bookmarkedWidgets != null) return this.bookmarkedWidgets;
		var statement = this.dbConn.createStatement("SELECT * FROM widgets ORDER BY bookmark DESC, channel DESC,lastOpen DESC;");
		var wrapper = Components.classes["@mozilla.org/storage/statement-wrapper;1"].
                createInstance(Components.interfaces.mozIStorageStatementWrapper);
		wrapper.initialize(statement);
		var results = [];
		try {
			wrapper.reset();
			while(wrapper.step()){
//				this.LOG("Loop1:"+wrapper.row.id+","+wrapper.row.name+","+wrapper.row.widgetArgs);
				results.push({
						id : wrapper.row.id,
						name : wrapper.row.name,
						widgetUrl : wrapper.row.widgetUrl,
						widgetArgs : JSON.parse(wrapper.row.widgetArgs),
						screenX : wrapper.row.screenX,
						screenY : wrapper.row.screenY,
						timeAdd : wrapper.row.timeAdd,
						timeMod : wrapper.row.timeMod,
						lastOpen : wrapper.row.lastOpen,					
						bookmark : wrapper.row.bookmark,
						startWithFirefox : wrapper.row.startWithFirefox,
						windowStates : JSON.parse(wrapper.row.windowStates),
						thumbnail : wrapper.row.thumbnail,
						thumbUrl : wrapper.row.thumbUrl,
						iconUrl : wrapper.row.iconUrl,
						timesVisited : wrapper.row.timesVisited
					});
//				this.LOG("Loop2:"+wrapper.row.id+","+wrapper.row.name+","+wrapper.row.location);
			}
		} finally {
			wrapper.statement.finalize();
		}
		this.bookmarkedWidgets = results;
		return results;
	},
	getAllBookmarkedWidgets : function(){
		this.LOG("getAllBookmarkedWidgets")
		if (this.bookmarkedWidgets != null) return this.bookmarkedWidgets;
		var statement = this.dbConn.createStatement("SELECT * FROM widgets WHERE bookmark = 1 ORDER BY lastOpen DESC;");
		var wrapper = Components.classes["@mozilla.org/storage/statement-wrapper;1"].
                createInstance(Components.interfaces.mozIStorageStatementWrapper);
		wrapper.initialize(statement);
		var results = [];
		try {
			wrapper.reset();
			while(wrapper.step()){
//				this.LOG("Loop1:"+wrapper.row.id+","+wrapper.row.name+","+wrapper.row.widgetArgs);
				results.push({
						id : wrapper.row.id,
						name : wrapper.row.name,
						widgetUrl : wrapper.row.widgetUrl,
						widgetArgs : JSON.parse(wrapper.row.widgetArgs),
						screenX : wrapper.row.screenX,
						screenY : wrapper.row.screenY,
						timeAdd : wrapper.row.timeAdd,
						timeMod : wrapper.row.timeMod,
						lastOpen : wrapper.row.lastOpen,					
						bookmark : wrapper.row.bookmark,
						startWithFirefox : wrapper.row.startWithFirefox,
						windowStates : JSON.parse(wrapper.row.windowStates),
						thumbnail : wrapper.row.thumbnail,
						thumbUrl : wrapper.row.thumbUrl,
						iconUrl : wrapper.row.iconUrl,
						timesVisited : wrapper.row.timesVisited
					});
//				this.LOG("Loop2:"+wrapper.row.id+","+wrapper.row.name+","+wrapper.row.location);
			}
		} finally {
			wrapper.statement.finalize();
		}
		this.bookmarkedWidgets = results;
		return results;
	},
	//id, name, widgetArgs{location, docX, docY,  width, height, browserWidth, browserHeight,zoom}, screenX, screenY, bookmark, startWithFirefox, windowStates
	modifyWidget : function(id, args){
		try {
			var sql = "UPDATE widgets SET ";
			if (args.name != null){	sql += "name=:name,";}
			if (args.widgetArgs != null){	sql += "widgetArgs=:widgetArgs,";}
			if (args.screenX != null){	sql += "screenX=:screenX,";}
			if (args.screenY != null){	sql += "screenY=:screenY,";}
			if (args.bookmark != null){	sql += "bookmark=:bookmark,";}
			if (args.startWithFirefox != null){	sql += "startWithFirefox=:startWithFirefox,";}
			if (args.windowStates != null){	sql += "windowStates=:windowStates,";}
			if (args.thumbnail != null){ sql += "thumbnail=:thumbnail,";}
			if (args.thumbUrl != null){ sql += "thumbUrl=:thumbUrl,";}
			if (args.iconUrl != null){ sql += "iconUrl=:iconUrl,";}
			sql += "timeMod=datetime('now'),lastOpen=datetime('now'),timesVisited = timesVisited + 1 WHERE id=:id;";
			this.LOG(sql);
			var stmt = this.dbConn.createStatement(sql);
			stmt.params.id = id;
			if (args.name != null){	stmt.params.name = args.name;}
			if (args.widgetArgs != null){	stmt.params.widgetArgs = JSON.stringify(args.widgetArgs);}
			if (args.screenX != null){	stmt.params.screenX = args.screenX;}
			if (args.screenY != null){	stmt.params.screenY = args.screenY;}
			if (args.bookmark != null){	stmt.params.bookmark = args.bookmark;}
			if (args.startWithFirefox != null){	stmt.params.startWithFirefox = args.startWithFirefox;}
			if (args.windowStates != null){	stmt.params.windowStates = JSON.stringify(args.windowStates);}
			if (args.thumbnail != null){ stmt.params.thumbnail = args.thumbnail;}
			if (args.thumbUrl != null){ stmt.params.thumbUrl = args.thumbUrl;}
			if (args.iconUrl != null){ stmt.params.iconUrl = args.iconUrl;}
			stmt.execute();
			stmt.finalize();
//			this.modifyBookmark(args);
		} catch (e){
			this.reportError(e);
		}
	},
	hideAll : function(){
		try {
			var enumerator = wm.getEnumerator("mozilla:favpart_widget");
			while(enumerator.hasMoreElements()) {
				var win = enumerator.getNext();
				// |win| is [Object ChromeWindow] (just like |window|), do something with it
				win.widget.setShow(false);
			}
		} catch (e){
			this.reportError(e);
		}
	},
	showAll : function(){
		try {
			var enumerator = wm.getEnumerator("mozilla:favpart_widget");
			while(enumerator.hasMoreElements()) {
				var win = enumerator.getNext();
				// |win| is [Object ChromeWindow] (just like |window|), do something with it
				win.widget.setShow(true);
				win.focus();
				if (win.dockable){
					win.dockable.hiding = false;
					win.dockable.showAndHideDockable(true);
				}
			}
		} catch (e){
			this.reportError(e);
		}
	},
	doSearch : function(data){
		try {
			if (this.searchWin && !this.searchWin.closed){
				this.LOG("searchWin already open");
				this.searchWin.widget.doSearch(data);
			} else {
				try {
					var result = this.getWidget(SEARCH_WIDGET_ID);
					if (result == null){
						this.LOG("no search widget.");
						return;
					}
					if (result.widgetArgs == null){
						result.widgetArgs = {data:data};
					} else {
						result.widgetArgs.data = data;
					}
					this.searchWin = this.raiseWidget(result);
		//			this.openWidgetManager();
				} catch (e){
					this.reportError(e);
				}
			}
		} catch (e){
			this.reportError(e);
		}
	},
	doGrabPic : function(picId){
		try {
			if (this.picWin && !this.picWin.closed){
				this.LOG("picWin already open");
				this.picWin.widget.doGrabPic(picId);
			} else {
				try {
					var result = this.getWidget(PIC_WIDGET_ID);
					if (result == null){
						this.LOG("no pic widget.");
						return;
					}
					if (result.widgetArgs == null){
						result.widgetArgs = {picId:picId};
					} else {
						result.widgetArgs.picId = picId;
					}
					this.picWin = this.raiseWidget(result);
		//			this.openWidgetManager();
				} catch (e){
					this.reportError(e);
				}
			}
		} catch (e){
			this.reportError(e);
		}
	},
	playMusic : function(songId){
		try {
			if (this.musicWin && !this.musicWin.closed){
				this.LOG("picWin already open");
				this.musicWin.widget.playMusic(songId);
			} else {
				try {
					var result = this.getWidget(MUSIC_WIDGET_ID);
					if (result == null){
						this.LOG("no music widget.");
						return;
					}
					if (result.widgetArgs == null){
						result.widgetArgs = {songId:songId};
					} else {
						result.widgetArgs.songId = songId;
					}
					this.musicWin = this.raiseWidget(result);
		//			this.openWidgetManager();
				} catch (e){
					this.reportError(e);
				}
			}
		} catch (e){
			this.reportError(e);
		}
	},
	closeSearchWin : function(force){
		this.LOG("closeSearchWin");
		if (this.searchWin && !this.searchWin.closed){
			if (this.searchWin.widget != null){
				this.searchWin.widget.closeSearch(force);
			} else {
				this.searchWin.close();
			}
		}
	},
	closePicWin : function(force){
		this.LOG("closePicWin");
		if (this.picWin && !this.picWin.closed){
			if (this.picWin.widget != null){
				this.picWin.widget.closePic(force);
			} else {
				this.picWin.close();
			}
		}
	},
	checkQuit : function(){
		if (this.getPref("closewithfirefox",true) == false){
			return;
		}
		var countMainWin = 0;
		var countFavWin = 0;
		var enumerator = wm.getEnumerator("navigator:browser");
		while(enumerator.hasMoreElements()) {
			var win = enumerator.getNext();
			countMainWin++;
		}
		enumerator = wm.getEnumerator("mozilla:favpart_widget");
		while(enumerator.hasMoreElements()) {
			var win = enumerator.getNext();
			if (win.widget && (	win.widget.args.widgetUrl == "chrome://livemargins/content/playerWindow.xul"
					|| win.widget.args.widgetUrl != "chrome://livemargins/content/videoPlayer.xul")){
				countFavWin++;
			}
		}
		if (countMainWin == 0){
			//deal with confirmation
			if (countFavWin != 0 && this.widgetManagerWin != null && !this.widgetManagerWin.closed && this.getPref("nocloseconfirm",false)== false){
				var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
				var check = { value: false };
				var strbundle = Components.classes["@mozilla.org/intl/stringbundle;1"].
						getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://livemargins/locale/livemargins.properties");
				var confirmTitle = strbundle.GetStringFromName("confirm.title");
				var confirmContent = strbundle.GetStringFromName("confirm.content");
				var confirmCheck = strbundle.GetStringFromName("confirm.check");

				var button = prompts.confirmCheck(null,
				 confirmTitle,
				 confirmContent,
				 confirmCheck,
				 check);
				if (check.value == true){// deal with the settings
					this.setPref("nocloseconfirm",true);
					if (button == 1){
						this.setPref("closewithfirefox",true);
					}else {
						this.setPref("closewithfirefox",false);
					}
				}
				
				//whether close the window or not
				if (button == 1){
					this.closeAllFavpartWindows();
					return;
				} else {
					return;
				}
				 
			}
			this.closeAllFavpartWindows();
		}
	},
	closeAllFavpartWindows : function(){
		var enumerator = wm.getEnumerator("mozilla:favpart_widget");
		while(enumerator.hasMoreElements()) {
			var win = enumerator.getNext();
			win.close();
		}
		if (this.widgetManagerWin != null){
			this.widgetManagerWin.close();
		}
	}
};

var thumbnail_vars = {
	width : 80,
	height : 45,
	aspectRatio: 0.5625, // 16:9
};
favpart_manager.LOG("init done");
